package huffman;

/** Represents a source of a sequence of boolean values.
 * 
 * @author Theodore Norvell
 *
 */
public interface BooleanSource {
	/** Is this sequence empty?
	 * 
	 * @return true if there are no more values.
	 */
	boolean isEmpty();

	/** Get the first item.
	 * Precondition: ! isEmpty() 
	 * @return The first item of the sequence, not yet removed.
	 */
	boolean getHead();

	/** Remove the first item of the sequence.
	 * The current second item becomes the head
	 * etc.
	 * Precondition: ! isEmpty() 
	 */
	void removeHead();

}
