/**
 * 
 */
package huffman;

import java.util.LinkedList;

/** This class is used to make mock objects implementing
 * both the BooleandSink and BooleanSource interfaces.
 * @author Theodore Norvell
 *
 */
public class MockBooleanSequence extends LinkedList<Boolean> implements BooleanSink, BooleanSource {

	/**
	 * @see huffman.BooleanSink#put(boolean)
	 */
	public void put(boolean b) {
		add(b) ;
	}

	/**
	 * @see huffman.BooleanSource#getHead()
	 */
	public boolean getHead() {
		return element();
	}

	/**
	 * @see huffman.BooleanSource#removeHead()
	 */
	public void removeHead() {
		removeFirst() ;
	}
}
