package huffman;

import org.junit.Assert;
import org.junit.Test;

public class TestConstructBranchNode {

	@Test public void testConstructBranchNode() {
		LeafNode leaf0 = new LeafNode('a', 15) ;
		LeafNode leaf1 = new LeafNode('e', 16) ;
		LeafNode leaf2 = new LeafNode('k', 17) ;
		LeafNode leaf3 = new LeafNode('g', 7) ;
		LeafNode leaf4 = new LeafNode('h', 10) ;
		
		BranchNode branch5 = new BranchNode(leaf0, leaf1) ;
		BranchNode branch6 = new BranchNode(leaf3, leaf4) ;
		BranchNode branch7 = new BranchNode(leaf2, branch6 ) ;
		BranchNode root = new BranchNode(branch5, branch7 ) ;
		
		Assert.assertEquals(branch5, leaf0.getParent()) ;
		Assert.assertEquals(branch5, leaf1.getParent()) ;
		Assert.assertEquals(leaf0, branch5.getLeft() ) ;
		Assert.assertEquals(leaf1, branch5.getRight() ) ;
		Assert.assertEquals(31, branch5.getFrequency() ) ;
		
		Assert.assertEquals(branch6, leaf3.getParent()) ;
		Assert.assertEquals(branch6, leaf4.getParent()) ;
		Assert.assertEquals(leaf3, branch6.getLeft() ) ;
		Assert.assertEquals(leaf4, branch6.getRight() ) ;
		Assert.assertEquals(17, branch6.getFrequency() ) ;
		
		Assert.assertEquals(branch7, leaf2.getParent()) ;
		Assert.assertEquals(branch7, branch6.getParent()) ;
		Assert.assertEquals(leaf2, branch7.getLeft() ) ;
		Assert.assertEquals(branch6, branch7.getRight() ) ;
		Assert.assertEquals(34, branch7.getFrequency() ) ;
		
		Assert.assertEquals(root, branch5.getParent()) ;
		Assert.assertEquals(root, branch7.getParent()) ;
		Assert.assertEquals(branch5, root.getLeft() ) ;
		Assert.assertEquals(branch7, root.getRight() ) ;
		Assert.assertEquals(65, root.getFrequency() ) ;
		
		Assert.assertEquals(null , root.getParent() ) ;
	}
}
