package huffman;

import org.junit.Test;

public class TestEncode {
	
	@Test public void testEncode() {
		LeafNode leaf0 = new LeafNode('a', 15) ;
		LeafNode leaf1 = new LeafNode('e', 16) ;
		LeafNode leaf2 = new LeafNode('k', 17) ;
		LeafNode leaf3 = new LeafNode('g', 7) ;
		LeafNode leaf4 = new LeafNode('h', 10) ;

		BranchNode branch5 = new BranchNode(leaf0, leaf1) ;
		BranchNode branch6 = new BranchNode(leaf3, leaf4) ;
		BranchNode branch7 = new BranchNode(leaf2, branch6 ) ;
		BranchNode root = new BranchNode(branch5, branch7 ) ;
		
		MockBooleanSequence seq = new MockBooleanSequence() ;
		
		root.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[0] ) ;
		branch5.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true} ) ;
		branch6.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false} ) ;
		branch7.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false, false} ) ;
		leaf0.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false, false,
				true, true} ) ;
		leaf1.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false, false,
				true, true,
				true, false} ) ;
		leaf2.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false, false,
				true, true,
				true, false,
				false, true } ) ;
		leaf3.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false, false,
				true, true,
				true, false,
				false, true,
				false, false, true } ) ;
		leaf4.encode(seq) ;
		TestUtilities.compareSeq( seq, new boolean[]{true, false, false, false,
				true, true,
				true, false,
				false, true,
				false, false, true,
				false, false, false} ) ;
	}

}
