package huffman;

import org.junit.Assert;
import org.junit.Test;

public class TestTreeEncode {

	@Test public void testTree() {
		int[] frequencies = new int[] { 17, 16, 15, 10, 8 } ;
		char[] symbols = new char[] { 'k', 'e', 'a', 'h', 'g'} ;
		Tree tree = new Tree( frequencies, symbols ) ;
		
		char[] message0 = new char[] {'a'} ;
		MockBooleanSequence seq0 = new MockBooleanSequence() ;
		TestUtilities.encodeMessage(tree, message0, seq0) ; 
		Assert.assertEquals( seq0.size(), 2) ;

		char[] message1 = new char[] {'e'} ;
		MockBooleanSequence seq1 = new MockBooleanSequence() ;
		TestUtilities.encodeMessage(tree, message1, seq1) ; 
		Assert.assertEquals( seq1.size(), 2) ;

		char[] message2 = new char[] {'k'} ;
		MockBooleanSequence seq2 = new MockBooleanSequence() ;
		TestUtilities.encodeMessage(tree, message2, seq2) ; 
		Assert.assertEquals( seq2.size(), 2) ;

		char[] message3 = new char[] {'g'} ;
		MockBooleanSequence seq3 = new MockBooleanSequence() ;
		TestUtilities.encodeMessage(tree, message3, seq3) ; 
		Assert.assertEquals( seq3.size(), 3) ;

		char[] message4 = new char[] {'h'} ;
		MockBooleanSequence seq4 = new MockBooleanSequence() ;
		TestUtilities.encodeMessage(tree, message4, seq4) ; 
		Assert.assertEquals( seq4.size(), 3) ;
	}
}
